(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('@fortawesome/fontawesome')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/platform-browser', '@fortawesome/fontawesome'], factory) :
	(factory((global.angularFontAwesome = {}),global.ng.core,global.ng.platformBrowser,global.fontawesome));
}(this, (function (exports,core,platformBrowser,fontawesome) { 'use strict';

var __assign = (undefined && undefined.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} i
 * @return {?}
 */
function isIconLookup(i) {
    return (/** @type {?} */ (i)).prefix !== undefined && (/** @type {?} */ (i)).iconName !== undefined;
}
/**
 * @param {?} iconSpec
 * @return {?}
 */
function normalizeIconArgs(iconSpec) {
    if (typeof iconSpec === 'undefined' || iconSpec === null) {
        return null;
    }
    if (isIconLookup(iconSpec)) {
        return iconSpec;
    }
    if (Array.isArray(iconSpec) && (/** @type {?} */ (iconSpec)).length === 2) {
        return { prefix: iconSpec[0], iconName: iconSpec[1] };
    }
    if (typeof iconSpec === 'string') {
        return { prefix: 'fas', iconName: iconSpec };
    }
}
/**
 * @param {?} key
 * @param {?} value
 * @return {?}
 */
function objectWithKey(key, value) {
    return ((Array.isArray(value) && value.length > 0) || (!Array.isArray(value) && value)) ? (_a = {}, _a[key] = value, _a) : {};
    var _a;
}
/**
 * @record
 */

/**
 * @param {?} props
 * @return {?}
 */
function classList(props) {
    var /** @type {?} */ classes = (_a = {
            'fa-spin': props.spin,
            'fa-pulse': props.pulse,
            'fa-fw': props.fixedWidth,
            'fa-border': props.border,
            'fa-li': props.listItem,
            'fa-flip-horizontal': props.flip === 'horizontal' || props.flip === 'both',
            'fa-flip-vertical': props.flip === 'vertical' || props.flip === 'both'
        }, _a["fa-" + props.size] = props.size !== null, _a["fa-rotate-" + props.rotate] = props.rotate !== null, _a["fa-pull-" + props.pull] = props.pull !== null, _a);
    return Object.keys(classes)
        .map(function (key) { return classes[key] ? key : null; })
        .filter(function (key) { return key; });
    var _a;
}
var FaIconComponent = (function () {
    function FaIconComponent(sanitizer) {
        this.sanitizer = sanitizer;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    FaIconComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        var /** @type {?} */ iconSpec = normalizeIconArgs(this.icon);
        var /** @type {?} */ classOpts = {
            icon: null,
            spin: this.spin,
            pulse: this.pulse,
            fixedWidth: this.fixedWidth,
            border: this.border,
            listItem: this.listItem,
            flip: this.flip,
            size: this.size || null,
            rotate: this.rotate || null,
            pull: this.pull || null
        };
        var /** @type {?} */ classes = objectWithKey('classes', classList(classOpts).concat((this.className || '').split(' ')));
        var /** @type {?} */ transform = objectWithKey('transform', (typeof this.transform === 'string') ?
            fontawesome.parse.transform(this.transform) : this.transform);
        var /** @type {?} */ mask = objectWithKey('mask', normalizeIconArgs(this.mask));
        var /** @type {?} */ renderedIcon = fontawesome.icon(iconSpec, __assign({}, classes, transform, mask, { symbol: this.symbol }));
        // @TODO: make sure that it doesn't break things to do html[0] here.
        this.renderedIconHTML = this.sanitizer.bypassSecurityTrustHtml(renderedIcon.html[0]);
    };
    FaIconComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'fa-icon',
                    template: ""
                },] },
    ];
    /** @nocollapse */
    FaIconComponent.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer, },
    ]; };
    FaIconComponent.propDecorators = {
        "icon": [{ type: core.Input },],
        "mask": [{ type: core.Input },],
        "symbol": [{ type: core.Input },],
        "className": [{ type: core.Input },],
        "fixedWidth": [{ type: core.Input },],
        "spin": [{ type: core.Input },],
        "pulse": [{ type: core.Input },],
        "border": [{ type: core.Input },],
        "listItem": [{ type: core.Input },],
        "flip": [{ type: core.Input },],
        "size": [{ type: core.Input },],
        "rotate": [{ type: core.Input },],
        "pull": [{ type: core.Input },],
        "transform": [{ type: core.Input },],
        "renderedIconHTML": [{ type: core.HostBinding, args: ['innerHTML',] },],
    };
    return FaIconComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var FontAwesomeModule = (function () {
    function FontAwesomeModule() {
    }
    FontAwesomeModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        FaIconComponent,
                    ],
                    exports: [
                        FaIconComponent,
                    ],
                },] },
    ];
    /** @nocollapse */
    FontAwesomeModule.ctorParameters = function () { return []; };
    return FontAwesomeModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

exports.FaIconComponent = FaIconComponent;
exports.FontAwesomeModule = FontAwesomeModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-fontawesome.umd.js.map
