import { OnChanges, SimpleChanges } from '@angular/core';
import { DomSanitizer, SafeHtml } from '@angular/platform-browser';
import { FaSymbol, FlipProp, IconProp, PullProp, RotateProp, SizeProp, Transform } from '@fortawesome/fontawesome';
export interface Props {
    icon: IconProp;
    mask?: IconProp;
    className?: string;
    spin?: boolean;
    pulse?: boolean;
    border?: boolean;
    fixedWidth?: boolean;
    listItem?: boolean;
    flip?: FlipProp;
    size?: SizeProp;
    pull?: PullProp;
    rotate?: RotateProp;
    transform?: string | Transform;
    symbol?: FaSymbol;
    style?: any;
}
export declare class FaIconComponent implements OnChanges {
    private sanitizer;
    icon: IconProp;
    mask?: IconProp;
    symbol?: FaSymbol;
    className?: string;
    fixedWidth?: boolean;
    spin?: boolean;
    pulse?: boolean;
    border?: boolean;
    listItem?: boolean;
    flip?: FlipProp;
    size?: SizeProp;
    rotate?: RotateProp;
    pull?: PullProp;
    transform?: Transform;
    renderedIconHTML: SafeHtml;
    constructor(sanitizer: DomSanitizer);
    ngOnChanges(changes: SimpleChanges): void;
}
